{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 4096,0,0}
uses crtc;
const
 poc_d=5;
 kod:array[1..poc_d] of string[40]=
 ('̊؎ڍϼ'
 ,'֐ҕ젡兣Ԗ'
 ,''
 ,''
 ,'ESCRZYAIENUUTODLLescrzyaienuutodll'
);
 popis:array[1..poc_d] of string[15]=(
'Win-1250','Latin-2','Kamenicky','KOI-8','bez diakritiky');
 delka_diakritiky=34;
label r;
var fi,fo:file;
 ni,no:string;
 s:array[1..4096]of char;
 ip,op,id,od:string;
 i,l:longint;
 j,k:word;
 e:boolean;
 ch:char;
 vstupni_d:byte;
 vystupni_d:byte;

function selcoding:byte;
begin
 repeat
 ch:=readkey;
 until (ch>='1') and (ch<=chr(poc_d+ord('0')));
 selcoding:=ord(ch)-ord('0');
end;

procedure wdiak;
begin
 for i:=1 to poc_d do writeln(' ',i,': ',popis[i]);
 writeln;
end;

function gc(i:integer):integer;
var s:string;
begin
 s:=paramstr(i);
 gc:=0;
 if (s[0]=#1) and (s[1]>='1') and (s[1]<=chr(poc_d+ord('0'))) then begin
  gc:=ord(s[1])-ord('0');
 end;
end;

begin
 Writeln('Konverze diakritiky v1.1 (c) 2001 Martin Petricek');
 vstupni_d:=gc(3);
 vystupni_d:=gc(4);
 if (vstupni_d=0) then begin
  writeln('Zdrojova diakritika:');
  wdiak;
  vstupni_d:=selcoding;
 end;
 if (vystupni_d=0) then begin
  writeln('Cilova diakritika:');
  wdiak;
  vystupni_d:=selcoding;
 end;
 id:=kod[vstupni_d];
 od:=kod[vystupni_d];
 ip:=popis[vstupni_d];
 op:=popis[vystupni_d];
 i:=0;
 no:='vystup.txt';
 if paramcount=0 then
 begin
  writeln('Nezadany zadne parametry.');
  writeln('Pouziti: diak <vstup> [vystup] [z_kodovani] [do_kodovani]');
  writeln(' Kodovani:');
  wdiak;
  halt;
 end else begin
  ni:=paramstr(1);
  if paramcount>1 then no:=paramstr(2);
 end;
 write(ni,' -> ',no,' z ',ip,' do ',op);
 assign(fi,ni);
 reset(fi,1);
 if ioresult <> 0 then begin
  writeln;
  writeln('!! Chybi soubor ',ni);
  halt;
 end;
 assign(fo,no);
 rewrite(fo,1);
 if ioresult <> 0 then begin
  close(fi);
  writeln;
  writeln('!! Chyba: nelze otevrit ',no);
  halt;
 end;
 repeat
  l:=filesize(fi)-i;
  if l>4096 then l:=4096;
  inc(i,l);
  blockread(fi,s,l);
  for j:=1 to l do begin
   for k:=1 to delka_diakritiky do begin
    if s[j]=id[k] then begin
     s[j]:=od[k];
     break;
    end;
   end;
  end;
  blockwrite(fo,s,l);
  if ioresult<>0 then
  begin
   close(fi);
   close(fo);
   writeln;
   writeln('!! Chyba na disku pri konverzi!');
   halt;
  end;
 until (l<4096);
 writeln(' ... ',i,' bytu');
 close(fi);
 close(fo);
end.
